; Condrv.sys Manager `XCONT`

version:	.reg		'0.20'
date:		.reg		'September 8th,1995'

* Include Files ------------------------------ *

		.include	eririn.mac
		.include	doscall.mac
		.include	iocscall.mac

		.include	DecHUPAIR.MAC
		.include	EncHUPAIR.MAC

* -------------------------------------------- *

ARG_BUF_SIZE:	.equ		32*1024
STACK_SIZE:	.equ		8*1024
EXEC_NAME_SIZE:	.equ		128

		.offset		0
arg_buf_adr:	.ds.l		1
exec_name:	.ds.b		EXEC_NAME_SIZE
		.ds.b		STACK_SIZE
stack_end:
work_size:

STDIN_ATR:	.equ		$80c1
STDOUT_ATR:	.equ		$80c2
RTS_CODE:	.equ		$4e75		* gp
MOVEM_CODE:	.equ		$48e7		*

* CONDRV.SYS \̒` ------------------ *

CONDRV_MARK:	.equ		'hmk*'
bufstruct_size:	.equ		32

		.offset		-28
option_flag:	.ds.b		1
		.even
wait_count:	.ds		1
wait_init:	.ds		1
syscall_adddr:	.ds.l		1
		.ds.b		1		s
winkey_flag:	.ds.b		1
bufinp_addr:	.ds.l		1
keybuf_len:	.ds.l		1
keybuf_addr:	.ds.l		1
condrv_mark:	.ds.l		1
		.fail		*.ne.0
key_init_entry:

option_f_bit:	.equ	0
option_j_bit:	.equ	7

* -------------------------------------------- *
		.text
		.even
start_:
		HUPAIR
*
		pea	(end_-start_+work_size+$f0)
		pea	(16,a0)
		DOS	_SETBLOCK
		tst.l	d0
		bmi	memory_error
		lea	(end_,pc),a6
		lea	(stack_end,a6),sp

		pea	(ARG_BUF_SIZE)		pobt@mۂ
		move	#2,-(sp)		ʂ猟
		DOS	_MALLOC2
		addq.l	#6,sp
		move.l	d0,(arg_buf_adr,a6)
		bmi	memory_error
		movea.l	d0,a1

		tst.b	(a2)+
		beq	@f
		lea	(a2),a0
		bsr	DecodeHUPAIR
		move.l	d0,d7			̐
@@
		beq	check_stdin_redirect

		subq	#1,d7
		moveq	#0,d6			(łȂ)xł
arg_loop:
		move.l	a1,-(sp)
		lea	(a1),a0
		move.b	(a0)+,d0
		beq	next_arg_skip
		cmpi.b	#'-',d0
		beq	check_option

		lea	(command_list,pc),a2
		moveq	#0,d1
command_check_loop:
		bsr	strcmp
		bne	@f			Ⴄ
		tst.b	(a2)+
		beq	command_found
@@
		tst.b	(a2)+
		bne	@b
		addq	#2,d1
		tst.b	(a2)
		bne	command_check_loop
		bra	argument_err
command_found:
		move	(@f,pc,d1.w),d1
		jsr	(@f,pc,d1.w)
		bra	next_arg
@@
		.dc	command_on-@b
		.dc	command_off-@b
		.dc	command_k-@b
		.dc	command_kon-@b
		.dc	command_koff-@b
		.dc	command_push-@b
		.dc	command_pop-@b
		.dc	command_check-@b
		.dc	command_ver-@b

check_option:
		move.b	(a0)+,d0
next_opt:	cmpi.b	#'?',d0
		beq	print_usage
		ori.b	#$20,d0
		lea	(option_table,pc),a2
@@
		move.l	(a2)+,d1
		beq	argument_err
		cmp.b	d0,d1
		bne	@b
		swap	d1
		adda	d1,a2
		jsr	(a2)
		move.b	(a0)+,d0		IvV͑Ă悢
		bne	next_opt
next_arg:
		moveq	#-1,d6
next_arg_skip:
		movea.l	(sp)+,a1
@@		tst.b	(a1)+			̈
		bne	@b
		dbra	d7,arg_loop
		tst	d6
		bne	exit

* ȗ --------------------------------- *

check_stdin_redirect:
		clr.l	-(sp)
		DOS	_IOCTRL
		addq.l	#4,sp
		cmpi	#STDIN_ATR,d0
		beq	print_onoff		STDIN؂芷Ȃ

		lea	(stdin,pc),a0
		bsr	option_l		؂芷Ăꍇ XCONT -L- ƌȂ
exit:		DOS	_EXIT

print_onoff:
		bsr	get_bufinp_addr
		IOCS	_B_WPEEK
		subi	#MOVEM_CODE,d0
print_on_off:
		lea	(on_mes,pc),a0
		beq	print_a0_exit
		lea	(off_mes,pc),a0
print_a0_exit:
		move.l	a0,-(sp)
print_exit:	DOS	_PRINT
		DOS	_EXIT

* R}h n -------------------------------- *

command_k:
		bsr	get_condrv_work
		moveq	#winkey_flag,d1
		bsr	bpeek
		tst.b	d0
		bra	print_on_off

command_on:
		move	#MOVEM_CODE,d2
		bra	@f
command_off:
		move	#RTS_CODE,d2
@@
		bsr	get_bufinp_addr
		move	d2,d1
		IOCS	_B_WPOKE
		bra	conctrl_fncmod

command_kon:
		moveq	#0,d2
		bra	@f
command_koff:
		moveq	#-1,d2
@@
		bsr	get_condrv_work
		lea	(winkey_flag,a0),a1
		move	d2,d1
		IOCS	_B_BPOKE
		rts

command_check:
		clr	-(sp)
		bsr	get_condrv_work_sub
		beq	@f
		addq	#1,(sp)
@@
		DOS	_EXIT2

command_ver:
		bsr	get_condrv_syscall
		moveq	#-1,d0
		bsr	call_sys_call
		lea	(ver_print_buf,pc),a0
		move.l	d0,(a0)
		bmi	condrv_err2
		bra	print_a0_exit

command_push:
		moveq	#1,d2
		bra	@f
command_pop:
		pea	(conctrl_fncmod,pc)	POP̓VXeXe[^X
		moveq	#0,d2
@@
		bsr	get_condrv_syscall
		move	d2,d1
		moveq	#$23,d0
		bsr	call_sys_call
		bmi	stack_error
		rts

* IvV --------------------------------- *

option_table:
		.irpc	%a,hvfjlx
		.dc	(option_%a-$-4),'&%a'
		.endm
		.dc.l	0

option_h:
print_usage:
		bsr	print_title
		pea	(usage_mes,pc)
		bra	print_exit

option_v:
		bsr	print_title
		DOS	_EXIT

option_f:
		pea	(conctrl_fncmod,pc)
		moveq	#1.shl.option_f_bit,d2
		bra	@f
option_j:
		moveq	#1.shl.option_j_bit,d2
@@
		bsr	get_value		1:set 0:clr
		subq.l	#1,d1
		bhi	over_val_err
		seq	d3			d3=-1:$.or.d2 d3=0:($.or.d2).eor.d2

		move.l	a0,-(sp)
		bsr	get_condrv_work
		lea	(option_flag,a0),a1
		IOCS	_B_BPEEK
		movea.l	(sp)+,a0

		or.b	d2,d0
		tst.b	d3
		bmi	@f
		eor.b	d2,d0
@@
		move.b	d0,d1
		subq.l	#1,a1
		IOCS	_B_BPOKE
		rts

option_l:
		bsr	check_filearg

		moveq	#STDIN,d5
		move.b	(a0),-(sp)
		move	(sp)+,d0
		move.b	(1,a0),d0
		cmp	(stdin,pc),d0
		beq	@f			-L - ̏ꍇ͕W͂ǂ

		clr	-(sp)
		move.l	a0,-(sp)
		DOS	_OPEN
		addq.l	#6,sp
		move.l	d0,d5
		bmi	fopen_error
@@
		moveq	#0,d2			d2=-1:W̓foCX

		move	d5,-(sp)
		clr	-(sp)
		DOS	_IOCTRL
		tst.l	d0
		bmi	ioctrl_error
		tst.b	d0
		bpl	@f			ubNfoCX̃t@C 0 Ԃ

		ori.b	#%0111_1110,d0
		addq.b	#1,d0
		seq	d2			CharDev&&STDINCON̓͂Ƃ݂Ȃ

		addq	#6,(sp)
		DOS	_IOCTRL
		tst.l	d0			-1.l œ͉
		beq	cannot_input_error	͕s̃LN^foCX
@@
		addq.l	#4,sp

		moveq	#-1,d4
		lsr.l	#8,d4
		move.l	d4,-(sp)
		DOS	_MALLOC
		and.l	d0,d4
		lsr.l	#1,d4			St[̔m
		move.l	d4,(sp)
		DOS	_MALLOC
		addq.l	#4,sp
		tst.l	d0
		bmi	memory_error
		movea.l	d0,a5

*XCON I[v
		move	#WOPEN,-(sp)
		pea	(xcon,pc)
		DOS	_OPEN
		addq.l	#6,sp
		tst.l	d0
		bmi	xcon_open_error
		swap	d5
		move	d0,d5			d5:file|XCON

		move	d5,-(sp)
		clr	-(sp)
		DOS	_IOCTRL
		tst.l	d0
		bmi	xcon_ioctrl_error
		tst.b	d0
		bpl	xcon_char_open_error	ʂ̃t@CI[vĂ܂

		addq	#7,(sp)
		DOS	_IOCTRL
		addq.l	#4,sp
		tst.l	d0			-1.l ŏo͉
		beq	cannot_output_error

* Wo͂؂芷Ă邩ׂ
		moveq	#0,d3			d3.hw=0:؂芷Ȃ
		pea	(STDOUT)		$0000_0001
		DOS	_IOCTRL
		addq.l	#4,sp
		cmpi	#STDOUT_ATR,d0
		beq	@f
		moveq	#-1,d3			d3.hw=-1:(ɏ)
@@
read_write_loop:
		swap	d5			XCON|file
		move.l	d4,-(sp)
		move.l	a5,-(sp)
		move	d5,-(sp)
		DOS	_READ
		lea	(10,sp),sp
		tst.l	d0
		bmi	fread_error
		beq	end_of_file

* W͂̏ꍇeof𒲂ׂ
		tst.b	d2
		beq	write_stdout
		lea	(a5),a2
		subq.l	#1,d0
@@
		move.b	(a2)+,d1
		cmpi.b	#$04,d1			^D
		beq	eof_found
		cmpi.b	#EOF,d1
		beq	eof_found
		dbra	d0,@b
		clr	d0
		subq.l	#1,d0
		bcc	@b
		bra	@f
eof_found:
		moveq	#-1,d2
@@
		move.l	a2,d0
		subq.l	#1,d0
		sub.l	a5,d0
		beq	end_of_file		seofꍇ

write_stdout:
		move.l	d0,-(sp)
		move.l	a5,-(sp)
		move	#STDOUT,-(sp)
		tst.l	d3
		bpl	@f
		DOS	_WRITE
@@
* XCON ɏ
		swap	d5			file|XCON
		move	d5,(sp)
		DOS	_WRITE
		lea	(10,sp),sp

		tst	d2			eofo
		bpl	read_write_loop
* Еt
end_of_file:
		DOS	_ALLCLOSE
@@		tst.b	(a0)+			͍̈Ō܂Ńt@CȂ̂
		bne	@b			߂Ă߂Ȃ悤ɂ
		subq.l	#1,a0
		rts

option_x:
		bsr	check_filearg

		pea	(ARG_BUF_SIZE+8)
		DOS	_MALLOC
		move.l	(sp)+,d6		size of ARG_BUF
		tst.l	d0
		bmi	memory_error
		movea.l	d0,a3
		lea	(8,a3),a4		#HUPAIR\0̕
		subq.l	#8,d6			V

		move.l	a0,-(sp)
		lea	(a0),a1
		lea	(exec_name,a6),a5
		lea	(a5),a0
		moveq	#EXEC_NAME_SIZE-1,d0
@@
		move.b	(a1)+,(a0)+
		dbeq	d0,@b
		bne	too_long_filename_error

		clr.l	-(sp)			
		move.l	a4,-(sp)		_~[̃R}hCobt@
		move.l	a5,-(sp)		t@C
		move	#2,-(sp)		
		DOS	_EXEC
		move.l	d0,d1
		bpl	exec_load_ok

* SLASH  BACKSLASH ɕςĎĂ݂
		lea	(a5),a0
		moveq	#'/',d1
@@
		move.b	(a0)+,d0
		beq	@f
		cmp.b	d0,d1
		bne	@b
		move.b	#'\',(-1,a0)
		bra	@b
@@
		DOS	_EXEC
		tst.l	d0
		bpl	exec_load_ok

		lea	(14,sp),sp
		move.l	d1,d0			xG[ȂO̕Ԓlg
		bra	load_error
exec_load_ok:
		lea	(14,sp),sp

		move.l	d6,d0			obt@e
		move.l	d7,d1
*		addq.l	#1,d1			̐(a1=)
		lea	(a4),a0			obt@擪
		bsr	EncodeHUPAIR
		bmi	memory_error		*

		move.l	d6,d1			obt@e
		lea	(a4),a1			obt@擪
		lea	(a5),a2			arg0(filename)
		bsr	SetHUPAIR
		bmi	memory_error		*

		suba.l	a3,a0			GR[hobt@
		move.l	a0,-(sp)		Kvȕ̑傫ɂ
		move.l	a3,-(sp)
		DOS	_SETBLOCK

		move.l	(arg_buf_adr,a6),(sp)	svɂȂobt@
		DOS	_MFREE
		addq.l	#8,sp

		clr.l	-(sp)			
		move.l	a4,-(sp)		R}hC
		move.l	a5,-(sp)		t@C
		move	#1,-(sp)		[ĥ
		DOS	_EXEC
		lea	(14,sp),sp
		move.l	d0,(sp)
		bmi	load_error

		PUSH	d0/a0-a4
		bsr	command_push
		bsr	command_off
		POP	d0/a0-a4

*		move.l	d0,-(sp)
		move	#4,-(sp)
		DOS	_EXEC
		move	d0,(sp)

		bsr	command_pop

		DOS	_EXIT2

* Sub ---------------------------------------- *

conctrl_fncmod:
		move.l	#$000e_ffff,-(sp)
		DOS	_CONCTRL
		bra	@f
print_title:
		pea	(title_mes,pc)
		DOS	_PRINT
@@
		addq.l	#4,sp
		rts

check_filearg:
		tst.b	(a0)+
		bne	@f

		dbra	d7,check_filearg
		bra	no_filename_error
@@
		subq.l	#1,a0
		movea.l	a0,a1
		rts

get_condrv_work:
		bsr	get_condrv_work_sub
		bne	condrv_err
		rts

get_condrv_work_sub:
		move	#$100+_KEY_INIT,-(sp)
		DOS	_INTVCG
		addq.l	#2,sp
		movea.l	d0,a0
		moveq	#condrv_mark,d1
		bsr	lpeek
		cmpi.l	#CONDRV_MARK,d0
		rts

get_bufinp_addr:
		bsr	get_condrv_work
		moveq	#bufinp_addr,d1
		bsr	lpeek
		movea.l	d0,a1
		rts

lpeek:
		moveq	#_B_LPEEK,d0
		bra	@f
bpeek:
		moveq	#_B_BPEEK,d0
@@		lea	(a0,d1.l),a1
		trap	#15
		rts

; łȂ return 1
get_value:
		bsr	is_number
		move.l	d0,d1
		bpl	@f

		moveq	#1,d1
		rts
1:
		mulu	#10,d1
		add.l	d0,d1
@@		bsr	is_number
		bpl	1b
		tst.l	d1
		rts

is_number:
		moveq	#0,d0
		move.b	(a0)+,d0
		subi.b	#'0',d0
		bmi	@f
		cmpi.b	#9,d0
		bhi	@f
		tst	d0
		rts
@@
		subq.l	#1,a0
		moveq	#-1,d0
		rts

strcmp:
		PUSH	d1/a1
@@
		move.b	(a1)+,d0
		beq	@f
		ori.b	#$20,d0
		move.b	(a2)+,d1
		beq	strcmp_not_equ
		cmp.b	d0,d1
		beq	@b
@@
		POP	d1/a1
		rts
strcmp_not_equ:
		subq.l	#1,a2
		moveq	#-1,d1
		bra	@b

get_condrv_syscall:
		bsr	get_condrv_work
		lea	(syscall_adddr,a1),a1
		IOCS	_B_LPEEK
		movea.l	d0,a0
		rts

call_sys_call:
		move.l	d0,-(sp)
		clr.l	-(sp)
		DOS	_SUPER
		move.l	d0,(sp)
		move.l	(4,sp),d0
		jsr	(a0)
		move.l	d0,(4,sp)
		DOS	_SUPER
		addq.l	#4,sp
		move.l	(sp)+,d0
		rts

* G[ --------------------------------- *
; exit(1):CONDRV.SYS gݍ܂ĂȂ
; exit(2):G[
; exit(3):ُ
; exit(4):t@CANZXɎs(܂XCON)
; exit(5):CONDRV.SYS ͏ił
; exit(6):X^bÑG[
; exit(7):t@C̎sɎs

condrv_err:
		lea	(condrv_err_mes,pc),a0
		moveq	#1,d1
		bra	1f
condrv_err2:
		lea	(condrv_err_mes2,pc),a0
		moveq	#5,d1
		bra	1f

memory_error:
		lea	(mem_err_mes,pc),a0
		moveq	#2,d1
		bra	1f

stack_error:
		addq.l	#1,d0
		beq	condrv_err2		d0.l=-1
		lea	(push_err_mes,pc),a0
		tst	d2
		bne	@f
		lea	(pop_err_mes,pc),a0
@@
		moveq	#6,d1
		bra	1f

1:
		suba.l	a1,a1
		bra	error_exit

argument_err:
		lea	(arg_err_mes,pc),a0
		bra	@f
over_val_err:
		lea	(val_err_mes,pc),a0
		bra	@f
small_val_err:
		lea	(val_err_mes,pc),a0
		move.l	#'',(6,a0)
		bra	@f
no_filename_error:
		lea	(nofilename_err_mes,pc),a0
		bra	@f
too_long_filename_error:
		lea	(too_long_filename_mes,pc),a0
		movea.l	(sp)+,a1
		bra	@f
@@
		moveq	#3,d1
		bra	error_exit

xcon_char_open_error:
		lea	(xcon_open_err_mes,pc),a0
		bra	@f
cannot_output_error:
		lea	(cant_out_err_mes,pc),a0
		move	#'o',(a0)
		bra	@f
@@
		lea	(xcon,pc),a1
		bra	1f

xcon_open_error:
		bsr	get_condrv_work		CONDRV.SYS gݍ܂Ăȏꍇ
		lea	(xcon,pc),a1		G[bZ[Wς
fopen_error:
		lea	(fopen_mes_tbl,pc),a0
		move.b	d0,(fopen_err_mes-fopen_mes_tbl,a0)
check_open_err:
		cmp.b	(a0)+,d0
		beq	1f
@@		tst.b	(a0)+
		bne	@b
		bra	check_open_err
xcon_ioctrl_error:
		lea	(xcon,pc),a1
ioctrl_error:
		lea	(ioctrl_err_mes,pc),a0
		bra	1f
cannot_input_error:
		lea	(cant_inp_err_mes,pc),a0
		bra	1f
fread_error:
		lea	(fread_err_mes,pc),a0
		bra	1f
1:
		moveq	#4,d1
		bra	error_exit

load_error:
		lea	(load_err_mes,pc),a0
		movea.l	(sp)+,a1

		moveq	#7,d1
		bra	error_exit

error_exit:
		move	#STDERR,-(sp)
		pea	(xcont_mes,pc)
		DOS	_FPUTS			XCONT:
		move.l	a0,(sp)
		DOS	_FPUTS			G[bZ[W
		move.l	a1,(sp)
		beq	@f
		DOS	_FPUTS			
@@		addq.l	#4,sp
		pea	(crlf,pc)
		DOS	_FPUTS			s
		move	d1,(sp)
		DOS	_EXIT2

* -------------------------------------------- *
		.data
		.even
title_mes:
		.dc.b	'Condrv.sys Manager `XCONT` Version ', version ,' ', date ,' Tachibana Eririn.'
crlf:		.dc.b	CR,LF,0
usage_mes:
		.dc.b	'Usage : [ON/OFF] [K/KON/KOFF] [PUSH/POP] [CHECK/VER] [-F/Jn] [-L<file>] [-X<command>] [-H/V]',CR,LF,0

command_list:
		.dc.b	'on',0
		.dc.b	'off',0
		.dc.b	'k',0
		.dc.b	'kon',0
		.dc.b	'koff',0
		.dc.b	'push',0
		.dc.b	'pop',0
		.dc.b	'check',0
		.dc.b	'ver',0
*		.dc.b	0

		.even
stdin:		.dc.b	'-',0
		.even
ver_print_buf:	.dc.b	0,0
*		.dc.b	0,0,0,0,CR,LF
on_mes:		.dc.b	'ON',CR,LF,0
off_mes:	.dc.b	'OFF',CR,LF,0

xcont_mes:	.dc.b	'XCONT:',0
xcon:		.dc.b	'XCON',0

condrv_err_mes:
		.dc.b	'CONDRV.SYS ͑gݍ܂Ă܂.',0
condrv_err_mes2:
		.dc.b	'CONDRV.SYS ͏ił.',0

mem_err_mes:
		.dc.b	'܂.',0

arg_err_mes:
		.dc.b	'ł:',0
nofilename_err_mes:
		.dc.b	't@Cw肵ĉ:',0
too_long_filename_mes:
		.dc.b	't@C܂:',0
load_err_mes:
		.dc.b	't@C[ho܂:',0

xcon_open_err_mes:
		.dc.b	'LN^foCXI[vł܂:',0

fopen_mes_tbl:	.dc.b	$fe,'t@C܂:',0
		.dc.b	$fd,'fBNg܂:',0
		.dc.b	$fc,'FCB ܂:',0
		.dc.b	$fb,'fBNg/{[x̓I[vł܂:',0
		.dc.b	$f3,'t@C̎wɌ肪܂:',0
		.dc.b	$f1,'hCuwɌ肪܂:',0
		.dc.b	$df,'w̃t@C̓bNĂ܂:',0
fopen_err_mes:	.dc.b	$00,'t@CI[vł܂(̑̃G[):',0
ioctrl_err_mes:
		.dc.b	'IOCTRLɎs܂:',0
		.even
val_err_mes:		       ****
		.dc.b	'l傫܂:',0
		.even
cant_inp_err_mes:
cant_out_err_mes:	 **
		.dc.b	'͕s\ȃt@Cł:',0
fread_err_mes:
		.dc.b	't@Cǂ߂܂:',0

push_err_mes:
		.dc.b	'ȏX^bNɐς߂܂.',0
pop_err_mes:
		.dc.b	'X^bN͋ł.',0

		.even
end_:
		.end	start_
* -------------------------------------------- *
